/*:ja
 * @target MZ
 *  
 * @command se
 * @arg name_
 * @type string
 * @arg argTxt
 * @type string
 * 
 * @command voice
 * @arg name_
 * @type string
 * @arg argTxt
 * @type string
 * @arg multiplay
 * @type boolean
 * 
 * @command bgm
 * @arg name_
 * @type string
 * 
 * @command voiceBgm
 * @arg name_
 * @type string
 * 
 * 
 * 
 * @param seVar
 * @type variable
 * 
 * @param voiceVar
 * @type variable
 * 
 */


(() => {
    'use strict';

    const script = document.currentScript;
    const param = PluginManagerEx.createParameter(script);

    AudioManager.IsSePlaying = function () {
        let a = false;
        this._seBuffers.forEach(function (audio) {
            a = audio.isPlaying();
        });
        return a;
    };
    const WebAudio_onError = WebAudio.prototype._onError;
    WebAudio.prototype._onError = function () {
        WebAudio_onError.apply(this, arguments)
        AudioManager.stopSe()
    };


    var prevId = 0;
    AudioManager.playSeEx = function (name_, argTxt, vol, dontPlayIfSePlaying) {
        if (dontPlayIfSePlaying && AudioManager.IsSePlaying()) return;

        if (argTxt) {
            if (argTxt.contains("|")) {
                argTxt = argTxt.split("|").map(a => Number(a))
            } else if (argTxt.contains("-")) {
                let min = Number(argTxt.split("-")[0]);
                let max = Number(argTxt.split("-")[1]);
                argTxt = [...Array(max - min + 1)].map((_, i) => i + min);
            } else {
                argTxt = [Number(argTxt)];
                prevId = 0
            }

            argTxt = argTxt.remove(prevId)
            let id = argTxt[Math.randomInt(argTxt.length)]
            name_ = name_.replace("@", id)
            prevId = id;
        }


        AudioManager.playSe({ "name": name_, "volume": vol ? vol : v(param.seVar), "pitch": 100, "pan": 0 })
    };
    AudioManager.playVoice = function (name_, argTxt, multiPlay) {
        AudioManager.playSeEx(name_, argTxt, v(param.voiceVar) * 5, multiPlay ? false : true)
    };
    AudioManager.playBgmEx = function (name_) {
        AudioManager.playBgm({ "name": name_, "volume": v(param.seVar), "pitch": 100, "pan": 0 })
    }
    AudioManager.playVoiceBgm = function (name_) {
        AudioManager.playBgm({ "name": name_, "volume": v(param.voiceVar) * 5, "pitch": 100, "pan": 0 })
    }


    PluginManagerEx.registerCommand(document.currentScript, "se", args => {
        AudioManager.playSeEx(args.name_, args.argTxt)
    });
    PluginManagerEx.registerCommand(document.currentScript, "voice", args => {
        AudioManager.playVoice(args.name_, args.argTxt, args.multiplay)
    });
    PluginManagerEx.registerCommand(document.currentScript, "bgm", args => {
        AudioManager.playBgmEx(args.name_)
    });
    PluginManagerEx.registerCommand(document.currentScript, "voiceBgm", args => {
        playVoiceBgm(args.name_)
    });






})();
