
/*:ja
 * @target MZ
 *
 * @command add
 * @arg picId
 * @type number
 * @arg dir
 * @type string
 * @arg min
 * @type number 
 * @arg max
 * @type number
 * @arg angle
 * @type number
 * @arg x
 * @type number
 * @min -1000
 *@arg y
 * @type number
 * @min -1000
 *
 * @command clear
 * @arg picId
 * @type number
 * 
 * @command show
 * @arg picId
 * @type number
 * 
 * @command hide
 * @arg picId
 * @type number
 * 
 * @command setup
 * @arg picId
 * @type number
 * 
 * */

(() => {
    'use strict';

    const script = document.currentScript;
    const param = PluginManagerEx.createParameter(script);



    Sprite_Picture.prototype.setupChildPic = function () {
        if (!this.childPic)
            this.childPic = this.addChild(new Sprite());
    }
    Sprite_Picture.prototype.createChildPic = function (picName, x, y) {
        var child = new Sprite(ImageManager.loadPicture(picName));
        child.anchor.x = 0.5;
        child.anchor.y = 0.5;
        child.x = x == -1 ? TouchInput.x : x;
        child.y = y == -1 ? TouchInput.y : y;
        //child.visible = this.childPic.visible
        this.childPic.addChild(child);

        return child;
    };
    Sprite_Picture.prototype.createRandomChildPic = function (dir, min, max, angleMax, x, y) {
        var no = Math.randomInt(max - min + 1) + min
        var picName = dir + "/" + no;
        let child = this.createChildPic(picName, x, y)
        child.angle = Math.randomInt(angleMax)
    };
    Sprite_Picture.prototype.clearChildPic = function () {
        this.childPic?.removeChildren()
    };
    Sprite_Picture.prototype.showChildPic = function () {
        // this.children.forEach(element => {
        //     element.visible = true
        // });
        if (this.childPic)
            this.childPic.show()
    };
    Sprite_Picture.prototype.hideChildPic = function () {
        if (this.childPic)
            this.childPic.hide()
    };

    const destroy = Sprite_Picture.prototype.destroy;
    Sprite_Picture.prototype.destroy = function () {
        //this.picture().GetPicure
        if (this.childPic) {
            this.removeChild(this.childPic)
            if (this.picture())
                this.picture().childPic = this.childPic
        }
        destroy.apply(this, arguments);
    };
    const update = Sprite_Picture.prototype.update;
    Sprite_Picture.prototype.update = function () {
        if (this.picture()?.childPic) {
            this.childPic = this.addChild(this.picture().childPic)
            this.picture().childPic = undefined
        }
        update.apply(this, arguments);
    };



    PluginManagerEx.registerCommand(document.currentScript, "add", args => {
        SceneManager.GetPicure(args.picId).createRandomChildPic(args.dir, args.min, args.max, args.angle, Number(args.x), Number(args.y))
    });

    PluginManagerEx.registerCommand(document.currentScript, "clear", args => {
        SceneManager.GetPicure(args.picId).clearChildPic()
    });
    PluginManagerEx.registerCommand(document.currentScript, "show", args => {
        SceneManager.GetPicure(args.picId).showChildPic()
    });
    PluginManagerEx.registerCommand(document.currentScript, "hide", args => {
        SceneManager.GetPicure(args.picId).hideChildPic()
    });
    PluginManagerEx.registerCommand(document.currentScript, "setup", args => {
        SceneManager.GetPicure(args.picId).setupChildPic()
    });





})();