/*:ja
 * @target MZ
 *
 * 
 * */


class Window_Dev extends Window_Selectable {
    constructor() {
        super(...arguments);
        this.padding = 0
        this.makeFontSmaller()
        this.refresh();
        this.activate();
        this.select(0);

    }
    initialize(rect) {
        super.initialize(rect);
    }
    maxCols() {
        return 1
    }
    itemHeight() {
        return 30; Math.floor(Graphics.height / (Graphics.width / this.itemWidth()));
    }

    itemPadding() {
        return 10;
    }
    contentsWidth() {
        return this.width
    }
    refresh() {
        super.refresh();
        this._refreshFrame()
    }

}
class WindowOnoff extends Sprite_Clickable {
    constructor(rect) {
        super(...arguments);
        // this.setHandler('ok', () => {
        //     this.toggle()
        //     this.activate()
        // });
        this.bitmap = ImageManager.loadPicture("icon/high")
        this.x = rect.x
        this.y = rect.y

        let btn2 = this.addChild(new Sprite_Clickable())
        btn2.bitmap = ImageManager.loadPicture("icon/low")
        btn2.x = 30
        btn2.onClick = () => {
            if (this.children[2].isOpen())
                this.children[2].close()
            else
                this.children[2].open()

            if (this.children[1].isOpen())
                this.children[1].close()
            else
                this.children[1].open()
        }
    }

    onClick() {
        this.children[1].visible = this.children[2].visible = !this.children[1].visible
    }

}
class WindowState extends Window_Dev {
    constructor() {
        super(...arguments);
        this.setHandler('ok', () => {
            $osawari.setState(this.currentItem().id)
            this.activate();
        });
        this.refresh();

    }
    maxItems() {
        return $dataSkills.length //50//ImageManager.validScreenshotCount();
    }
    drawItem(index) {
        const rect = this.itemRect(index);
        this.drawText($dataSkills[index] ? $dataSkills[index].id + ":" + $dataSkills[index].name : "", rect.x, rect.y, this.width);
    }
    currentItem() {
        return $dataSkills[this.index()];
    }

}
class WindowCommon extends Window_Dev {
    constructor() {
        super(...arguments);
        this.setHandler('ok', () => {
            $gameTemp.reserveCommonEvent(this.index());
            this.activate();
        });
        this.refresh();

    }
    maxItems() {
        return $dataCommonEvents.length //50//ImageManager.validScreenshotCount();
    }
    drawItem(index) {
        const rect = this.itemRect(index);
        this.drawText($dataCommonEvents[index] ? $dataCommonEvents[index].name : "", rect.x, rect.y, this.width);
    }


}
class WindowVar extends Window_Dev {
    constructor() {
        super(...arguments);
        this.setHandler('ok', () => {
            let value = window.prompt("", "");
            if (value)
                $gameVariables.setValue(this.index(), value)
            this.activate();
            this.refresh();
        });

    }
    drawItem(index) {
        const rect = this.itemRect(index);
        const value = $gameVariables.value([index])
        this.drawText($dataSystem.variables[index] + ": " + String(value), rect.x, rect.y, this.width);
    }
    maxItems() {
        return $gameVariables._data.length
    }

}
class WindowSw extends Window_Dev {
    constructor() {
        super(...arguments);
        this.setHandler('ok', () => {
            $gameSwitches.setValue(this.index(), !$gameSwitches.value(this.index()))
            this.activate();
            this.refresh();
        });

    }
    drawItem(index) {
        const rect = this.itemRect(index);
        const value = $gameSwitches.value(index)
        this.drawText($dataSystem.switches[index] + ": " + String(value), rect.x, rect.y, this.width);
    }
    maxItems() {
        return $gameSwitches._data.length
    }
}



(() => {
    'use strict';
    const script = document.currentScript;
    const param = PluginManagerEx.createParameter(script);

    const _Scene_Map_start = Scene_Map.prototype.start;
    Scene_Map.prototype.start = function () {
        _Scene_Map_start.apply(this, arguments);


        let parent
        parent = SceneManager._scene.addChild(new WindowOnoff(new Rectangle(30, 0, 150, 30)))
        parent.addChild(new WindowState(new Rectangle(0, 30, 150, 600)))
        let tmp = parent.addChild(new WindowCommon(new Rectangle(0, 30, 150, 600)))
        tmp.close()

        let height = 300

        parent = SceneManager._scene.addChild(new WindowOnoff(new Rectangle(500, 0, 150, 30)))
        parent.addChild(new WindowVar(new Rectangle(0, 30, 150, 600)))
        tmp = parent.addChild(new WindowSw(new Rectangle(0, 30, 150, 600)))
        tmp.close()

    };


})();