/*:ja
 * @target MZ
 *
 * @param enabled
 * @text テキスト有効
 * @default true
 * @type boolean
 *  
 * @param langVar
 * @type variable
 * 
 * @param sedir
 * @type string
 * 
 * @command Message
 * 
 * @arg argTxt
 * @type string
 * 
 * 
 * 
 * */



(() => {
    'use strict';

    const script = document.currentScript;
    const param = PluginManagerEx.createParameter(script);
    const prefix = "a"
    const offset = 2

    const _Window_Base_processEscapeCharacter = Window_Base.prototype.processEscapeCharacter;
    Window_Base.prototype.processEscapeCharacter = function (code, textState) {
        _Window_Base_processEscapeCharacter.apply(this, arguments);
        if (code === 'SE') {
            const seId = this.obtainEscapeParamString(textState);
            if (seId) {
                this.playEscapeAudio(seId);
            }
        }
    };

    Window_Base.prototype.obtainEscapeParamString = function (textState) {
        const arr = /^\[.+?]/.exec(textState.text.slice(textState.index));
        if (arr) {
            textState.index += arr[0].length;
            return arr[0].substring(1, arr[0].length - 1);
        } else {
            return '';
        }
    };
    const convertEscapeCharacters = Window_Base.prototype.convertEscapeCharacters;
    Window_Base.prototype.convertEscapeCharacters = function (text) {
        let t = convertEscapeCharacters.apply(this, arguments);

        return t.replace(/\x1bMSG\[(\d+)\]/gi, (_, p1) =>
            $externMessage.getText(p1, $gameVariables.value(param.langVar))
        );
    };



    Window_Base.prototype.playEscapeAudio = function (seId) {
        AudioManager.stopSe()
        AudioManager.playVoice(param.sedir + "/@", seId)
    };

    $externMessage.getText = function (lineNo, langId) {
        langId = langId ? langId : $gameVariables.value(param.langVar)
        var line = this._map[prefix + ('000' + lineNo).slice(-3)];
        return line[langId + offset]
    }
    $externMessage.getSex = function (lineNo) {
        var line = this._map[prefix + ('000' + lineNo).slice(-3)];
        return line[0]
    }
    $externMessage.getSe = function (lineNo) {

        var line = this._map[prefix + ('000' + lineNo).slice(-3)];
        return line[1]
    }

    $externMessage.message = function (no) {
        if (!param.enabled)
            return

        let txt = this.getText(no);
        let sex = this.getSex(no);
        let se = this.getSe(no);
        se = se ? "\\se[" + Number(se) + "]" : ""
        let color = sex == "f" ? "\\c[27]" : ""
        $gameMessage.newPage()
        $gameMessage.add(se + color + txt)
        $gameMap._interpreter.setWaitMode('message');
    }
    $externMessage.messageWhile = function (argTxt) {
        if (argTxt.contains("-")) {
            let start = Number(argTxt.split("-")[0]);
            let end = Number(argTxt.split("-")[1]);
            for (let i = start; i <= end; i++) {
                this.message(i)
            }
        } else if (argTxt.contains("|")) {
            let ids = argTxt.split("|").map(a => Number(a))
            ids.forEach(id => {
                this.message(id)
            });
        } else {
            this.message(Number(argTxt));
        }

    }
    PluginManagerEx.registerCommand(script, "Message", args => {
        $externMessage.messageWhile(String(args.argTxt))
    });

})();