/*:ja
 * @target MZ
 * 
 * @param taiken
 * @text 体験版
 * @type boolean
 * @default false
 * 
 * @param v1
 * @text メジャーバージョン
 * @type number
 * @default 0
 *  
 * @param v2
 * @text マイナーバージョン
 * @type number 
 * @default 1
 * 
 * @param LineSize
 * @type number 
 * @default 2
 * 
 * @command TouchUI
 * @text TouchUI
 *
 * @arg enable
 * @type boolean
 * 
 * @param taikenSwitch
 * @type switch
 * @default 1
 *
 * @param v1Var
 * @type variable
 * @default 0
 *  
 * @param v2Var
 * @type variable 
 * @default 0
 * 
 */


function v(id, value) {
    if (value != undefined) {
        $gameVariables.setValue(id, value)
    } else {
        return $gameVariables.value(id)
    }
}
function s(id, value) {
    if (value != undefined) {
        $gameSwitches.setValue(id, value)
    } else {
        return $gameSwitches.value(id)
    }
}

function log(str) {
    if ($gameTemp.isPlaytest())
        console.log(str);
}
function TouchUI(enable) {
    ConfigManager['touchUI'] = enable;
    ConfigManager.save();
    const s = SceneManager._scene;

    if (enable) {
        if (!s._menuButton) {
            s.createMenuButton();
            s.updateMenuButton();
        };
    } else {
        s._windowLayer.removeChild(s._menuButton);
        s._menuButton = null;
    }
}

(() => {
    'use strict';

    const script = document.currentScript;
    const param = PluginManagerEx.createParameter(script);

    var _DataManager_createGameObjects = DataManager.createGameObjects;
    DataManager.createGameObjects = function () {
        _DataManager_createGameObjects.apply(this, arguments);
        $gameSwitches.setValue(param.taikenSwitch, param.taiken)
        $gameVariables.setValue(param.v1Var, param.v1)
        $gameVariables.setValue(param.v2Var, param.v2)
    }


    // const console_log = console.log;
    // console.log = function (str) {
    //     if ($test)
    //         console_log(str)
    // }

    PluginManagerEx.registerCommand(script, "TouchUI", args => {
        TouchUI(args.enable);

    });
    const _Sprite_Timer_redraw = Sprite_Timer.prototype.redraw;
    Sprite_Timer.prototype.redraw = function () {
        log(this.timerText())
        this.bitmap.clear();
    };
    const _Scene_Map_callMenu = Scene_Map.prototype.callMenu;
    Scene_Map.prototype.callMenu = function () {
        SceneManager.push(Scene_Options)
    };

    Scene_Message.prototype.messageWindowRect = function () {
        const ww = Graphics.boxWidth;
        const wh = this.calcWindowHeight(param.LineSize, false) + 8;
        const wx = (Graphics.boxWidth - ww) / 2;
        const wy = 0;
        return new Rectangle(wx, wy, ww, wh);
    };

})();
