
/*:ja
 * @target MZ
 * 
 * 
 * @param picIdBg
 * @type number
 * @param picIdFg
 * @type number
 * @param picIdMap
 * @type number
 * @param picIdObj
 * @type number
 * @param picIdEfc
 * @type number
 * @param picIdItem
 * @type number
 * @param picIdItemMap
 * @type number
 * 
 * @param stateVar
 * @type variable
 * @param charaVar
 * @type variable
 * @param angleVar
 * @type variable
 * @param bgVar
 * @type variable
 * 
 * @param itemY
 * @type number
 * @default 600
 * 
 * 
 * @param beforStateChange
 * @type multiline_string
 * 
 * @param afterStateChange
 * @type multiline_string
 * 
 * 
 * @command set
 * @arg id
 * @type skill
 * 
 * @command next
 * 
 * @command return
 * 
 * @command reload
 * 
 * @command setDoneFlags
 * @command resetDoneFlags
 * 
 * @command enableAngle
 * @arg name
 * @type string
 * 
 * @command setObj
 * @arg name_
 * @type string 
 * 
 * @command setEfc
 * @arg name_
 * @type string 
 * 
 * 
 * */

var $osawari = null;
var $state = null;

(() => {
    'use strict';

    const script = document.currentScript;
    const param = PluginManagerEx.createParameter(script);


    class Osawari {

        constructor() {
            PixiApngAndGif.prototype.onLastFrame = this.onApngLastFrame.bind(this)
            Slot.onUse = this.onSlotUse.bind(this)
            PictureTouch.onTouchEvent = this.onTouchEvent.bind(this)
        }
        onNewGame() {
            this.currentState = null;
            this.baseStateId = 0;
            this.item = null;
            this.isRanning = false
            this.angles = []
            this.resetDoneFlags()
            //this.setState(1)

            let option = {
                buttonBind: "", commonEventId: 0, invalidSwitchId: 0, operand: 0, operationType: 0,
                pictureId: 0, script: "", switchId: 0, triggerType: 0, variableId: 0
            }
            let id
            id = param.picIdMap
            $gameScreen.addPictureEvent(id, 1, { ...option, pictureId: id, triggerType: 1 });
            $gameScreen.addPictureEvent(id, 4, { ...option, pictureId: id, triggerType: 4 });
            $gameScreen.addPictureEvent(id, 5, { ...option, pictureId: id, triggerType: 5 });
            $gameScreen.addPictureEvent(id, 6, { ...option, pictureId: id, triggerType: 6 });
            $gameScreen.addPictureEvent(id, 13, { ...option, pictureId: id, triggerType: 13 });
            id = param.picIdItemMap
            $gameScreen.addPictureEvent(id, 1, { ...option, pictureId: id, triggerType: 1 });
            $gameScreen.addPictureEvent(id, 6, { ...option, pictureId: id, triggerType: 6 });
            $gameScreen.addPictureEvent(id, 13, { ...option, pictureId: id, triggerType: 13 });

            $gameScreen.showPicture(param.picIdBg, "", 0, 0, 0, 100, 100, 255, 0);
            $gameScreen.showPicture(param.picIdFg, "", 0, 0, 0, 100, 100, 255, 0);
            $gameScreen.showPicture(param.picIdMap, "", 0, 0, 0, 100, 100, 0, 0);
            $gameScreen.showPicture(param.picIdItem, "", 1, 0, 0, 100, 100, 255, 0);
            $gameScreen.showPicture(param.picIdItemMap, "", 1, 0, 0, 100, 100, 0, 0);
            $gameScreen.showPicture(param.picIdObj, "", 1, 0, 0, 100, 100, 255, 0);
            $gameScreen.showPicture(param.picIdEfc, "", 1, 0, 0, 100, 100, 255, 0);

            let bg = SceneManager.GetPicure(param.picIdBg)
            bg.filters = [new PIXI.filters.OldFilmFilter(), new PIXI.filters.BlurFilter()]
            bg.filters[0].noise = bg.filters[0].sepia = bg.filters[0].scratch = 0
            bg.filters[0].vignettingAlpha = 1;
            bg.filters[0].vignetting = 0.1;
            bg.filters[0].vignettingBlur = 0.5
            bg.filters[1].blur = 5

            // $gameScreen.picture(param.picIdItem)._origin = 1
            // $gameScreen.picture(param.picIdItemMap)._origin = 1

            this.setState(1)
        }
        onMapStart() {
            //this.preloadPng($dataMap.note.split("\n"))
            this.angles = this.getAngles()
            this.setAngle(this.angles[0]?.name)
        }
        onApngLastFrame(pixiApngAndGif, state) {
            if (this.currentState.loop && pixiApngAndGif.sprite.pixiApngOption.FileName == $gameScreen.picture(param.picIdFg)._name)
                AudioManager.playSeEx(this.currentState.loop[0], this.currentState.loop[1])


            if (pixiApngAndGif.sprite.parent?._pictureId != param.picIdFg)
                return
            if (this.currentState.typeIs("aネクスト")) {
                this.nextState()
            } else if (this.currentState.typeIs("aリターン")) {
                this.returnState()
            }
        }
        onSlotUse(item) {
            if (this.item == item) return

            this.item = item;
            $gameScreen.picture(param.picIdItem)._name = ""
            $gameScreen.picture(param.picIdItemMap)._name = ""
            $gameScreen.picture(param.picIdItem)._origin = 1
            $gameScreen.picture(param.picIdItem).centering()
            $gameScreen.picture(param.picIdItem)._y = param.itemY
            $gameScreen.picture(param.picIdItemMap)._origin = 1
            $gameScreen.picture(param.picIdItemMap).centering()
            $gameScreen.picture(param.picIdItemMap)._y = param.itemY

            if (this.item.note) {
                this.showItem(0)
            }
            let cmn = $dataCommonEvents.find(event => event?.name === this.item.name)
            if (cmn)
                $gameTemp.reserveCommonEvent(cmn.id);
        }
        onTouchEvent = function (regionId, triggetId) {
            if (this.item) {
                if (triggetId == 4) {
                    //if (State.FindState(this.item.id, this.currentState.id, $dataArmors[regionId]?.name + "-1"))
                    s(3, true)
                }
                if (triggetId == 5) {
                    s(3, false)
                }
                this.TriggerAtion($dataArmors[regionId]?.name, triggetId)
            }
        }
        TriggerAtion(region, triggetId) {
            log(`TriggerAtion: region: ${region}  triggetId:${triggetId} state:${this.currentState.id}`)



            if (triggetId == 6 || triggetId == 5) {
                if (this.currentState.typeIs("リリース")) {
                    this.nextState()
                } else if (this.currentState.typeIs("リリースリターン")) {
                    this.returnState()
                } else if (this.currentState.typeIs("ドラッグ")) {
                    if (triggetId == 6) {
                        this.returnState()
                    } else {
                        this.nextState()
                    }
                }

                return
            }
            if (this.isRanning) return
            let state = State.FindState(this.item.id, this.baseStateId, region + "-" + triggetId)
            if (state) {
                log(`state found`)
                this.setState(state?.id)
            } else {
                log(`state not found`)
            }
        }
        onStateChange(id) {
            log("state set : " + id)
            if (!(id > 0)) {
                this.isRanning = false
                return
            }
            this.isRanning = true
            this.time = 0;
            this.timeoutEnabled = false
            this.currentState = $dataSkills[id]
            $state = this.currentState

            this.currentState.call()
            if (this.currentState.typeIs("ベース")) {
                this.baseStateId = this.currentState.id
            }
        }
        onAngleChange(name) {
            log(`set angle: ${name}`)
            let angle = this.angles.find(a => a.name == name)
            if (!angle) {
                log(`angle not found: ${name}`)
                return
            }
            this.angle = angle
            this.refleshBg()
            this.reload();
        }
        onCharaChange(value) {
            //this.preloadPng($dataMap.note.split("\n"))
            this.reload();
        }
        onBgChange(value) {
            this.bg = value
            this.refleshBg();
            this.reload();
        }
        onTimeout() {
            if (this.timeoutMethod == "next")
                this.nextState()
            else if (this.timeoutMethod == "prev")
                this.prevState()
            else if (this.timeoutMethod == "return")
                this.returnState()
            if (this.timeoutMethod == "jump")
                this.setStateByName(this.currentState.jump[0])

        }
        refleshBg() {
            $gameScreen.picture(param.picIdBg)._name = "bg/" + this.bg + "/" + this.angle.name
        }
        setState(id) {
            v(param.stateVar, id)
        }
        setAngle(name) {
            v(param.angleVar, name)
        }
        setChara(id) {
            v(param.charaVar, id)
        }

        setStateByName(name) {
            this.setState($dataSkills.find(a => a?.name == name).id)
        }

        nextState() {
            this.setState(this.currentState.id + 1)
        }
        prevState() {
            this.setState(this.currentState.id - 1)
        }
        returnState() {
            this.setState(this.baseStateId)
        }
        reload() {
            this.currentState.reload()
        }

        getAngles() {
            $dataMap.encounterList.forEach((encounter, index) => {
                encounter.name = $dataTroops[encounter.troopId].name
                encounter.index = index
            });
            return $dataMap.encounterList;
        }
        nextAngle() {
            let angle = this.angles[this.angle.index + 1]
            if (!angle || angle.weight < 1) {
                angle = this.angles[0]
            }
            this.setAngle(angle.name)
        }
        prevAngle() {
            let angle = this.angles[this.angle.index - 1]
            if (!angle || angle.weight < 1) {
                angle = this.angles[this.angles.length - 1]
            }
            this.setAngle(angle.name)
        }
        angleIsLast() {
            let validAngles = this.angles.filter(a => a.weight > 0)
            return this.angle.index == validAngles[validAngles.length - 1]?.index
        }
        angleIsFirst() {
            let validAngles = this.angles.filter(a => a.weight > 0)
            return this.angle.index == validAngles[0]?.index
        }
        enableAngle(name) {
            let angle = this.angles.find(a => a.name == name)
            angle.weight = 1
        }
        disableAngle(name) {
            let angle = this.angles.find(a => a.name == name)
            angle.weight = 0
        }




        showItem(index) {
            let name = this.item.note.split("\n")[index]
            $gameScreen.picture(param.picIdItem)._name = "items/large/" + this.item.name + "/" + name
            $gameScreen.picture(param.picIdItemMap)._name = "items/large/" + this.item.name + "/" + "map"
        }


        tglHint() {
            let pic;
            pic = $gameScreen.picture(param.picIdMap)
            pic._opacity = pic._opacity == 0 ? 55 : 0;
            pic = $gameScreen.picture(param.picIdItemMap)
            pic._opacity = pic._opacity == 0 ? 55 : 0;
        }



        setDoneFlags() {
            $dataSkills.forEach(a => a ? a.done = true : null)
        }
        resetDoneFlags() {
            $dataSkills.forEach(a => a ? a.done = false : null)
        }
    }


    class State {
        constructor(obj) {
            Object.assign(this, obj)
        }
        paramLineToValueArray(line) {
            let tmp = line.split(":")
            let value = tmp[1].split(",")
            let cond = tmp[2] ? tmp[2] : "true"

            if (eval(cond))
                return value
        }
        getParam(name) {
            if (this.note.length < 1)
                return

            let line = this.note.split("\n").find(a => a.startsWith(name + ":"))
            if (!line)
                return

            return this.paramLineToValueArray(line)

        }
        getParams(name) {
            if (this.note.length < 1)
                return []

            let lines = this.note.split("\n").filter(a => a.startsWith(name + ":"))
            let params = []
            lines.forEach(element => {
                let p = this.paramLineToValueArray(element)
                if (p)
                    params.push(p)
            });
            return params

        }


        static FindState(itemId, stateId, note) {
            let learning = $dataClasses[itemId]?.learnings?.find(
                a => (a.note == note) && (a.level == stateId || a.level == 1)
            )
            if (learning)
                return $dataSkills[learning.skillId]
        }

        typeIs(type) {
            let type2 = $dataSystem.skillTypes[this.stypeId]
            return (type2 == type)
        }
        getCommonsList() {
            let list = []
            this.effects.forEach(common => {
                list.push({ code: 117, indent: 0, parameters: [common.dataId] })
            });
            return list
        }
        showFg(duration) {
            if (this.description) {
                let name = String($gameVariables.value(param.charaVar)) + "/fg/" + $dataSkills[this.id].description
                //$gameScreen.picture(param.picIdFg).fadeDuration = duration
                $gameScreen.picture(param.picIdFg)._name = name
            }
        }
        reload() {
            this.showFg(0)
            this.showMap()
            this.playVBgm()
            this.setLoopSe()
        }
        showMap() {
            if (this.description) {
                let name = String($gameVariables.value(param.charaVar)) + "/map/" + $dataSkills[this.id].description
                $gameScreen.picture(param.picIdMap)._name = name
            }
        }
        playSe() {
            let value = this.getParam("se")
            if (value)
                AudioManager.playSeEx(value[0], value[1])
        }
        playVoice() {
            let value = this.getParam("v")
            if (value) {
                if (this.getParam("msg") && !this.done)
                    return
                AudioManager.playVoice(String(v(param.charaVar)) + "/@", value[0], value[1])
            }
        }
        setLoopSe() {
            let value = this.getParam("loop")
            if (value)
                this.loop = value
        }
        playBgm() {
            let value = this.getParam("bgm")
            if (value) {
                AudioManager.playBgmEx(value[0])
                return true
            }
            else
                return false

        }
        playVBgm() {
            let value = this.getParam("vbgm")
            if (value) {
                AudioManager.playVoiceBgm(value[0])
                return true
            }
            else
                return false
        }
        message(key) {
            let value = this.getParam(key)
            if (value) {
                if (value[1] || !this.done) {
                    $externMessage.messageWhile(value[0])
                }
            }
        }
        playObjOfEfc(type) {
            let name
            let id
            if (type == "obj") {
                name = this.message1
                id = param.picIdObj
            } else {
                name = this.message2
                id = param.picIdEfc
            }
            if (name.length < 1) {
                $gameScreen.picture(id)._name = ""
                return
            }
            $gameScreen.picture(id).effectOff(id)

            let cmn = $dataCommonEvents.find(event => event?.name === name);
            if (cmn && cmn.id > 0) {
                $gameMap.setupDynamicCommon(cmn.id)
            } else {
                $gameScreen.picture(id)._name = type + "/" + name
                $gameScreen.picture(id).moveToPointer()
            }
        }
        setJump() {
            let value = this.getParam("jump")
            if (value)
                this.jump = value
        }
        setChoice() {
            let value = this.getParam("choice")
            if (value) {
                this.choice = value
                this.choice = this.choice.map(a => $externMessage.getText(Number(a)))
            }
        }
        setTime() {
            let value = this.getParam("time")
            if (value) {
                $osawari.timeout = value[0]
                $osawari.timeoutEnabled = true
                $osawari.timeoutMethod = value[1]

            }
        }
        getItem() {
            let values = this.getParams("item")
            values.forEach(element => {
                let slotNo = element[0]
                let itemName = element[1]
                $slot.setByName(slotNo, itemName)
            });
        }


        call() {
            eval(param.beforStateChange)

            this.setChoice()
            this.setJump()
            this.setTime()

            $gameMap.setupDynamicInterpreter([
                { code: 901, indent: 0, parameters: [this, "pre"] },
                { code: 900, indent: 0, parameters: [this] },
                { code: 901, indent: 0, parameters: [this, "msg"] },
                { code: 902, indent: 0, parameters: [this] },
                { code: 903, indent: 0, parameters: [this] },
                // { code: 230, indent: 0, parameters: [60] },
                // , { code: 902, indent: 0, parameters: [] }
            ], 0)
        }
    }

    Game_Interpreter.prototype.command900 = function (params) {
        let state = params[0]
        state.showFg(state.tpCost)
        if (state.typeIs("ベース")) {
            state.showMap()
        }
        state.playVoice()
        state.playSe()
        if (!(state.playVBgm() || state.playBgm()))
            AudioManager.stopBgm()
        state.setLoopSe()

        state.playObjOfEfc("obj")
        state.playObjOfEfc("efc")
        return true
    };
    Game_Interpreter.prototype.command901 = function (params) {
        let state = params[0]
        state.message(params[1])
        this.setWaitMode("message");
        return true
    };
    Game_Interpreter.prototype.command902 = function (params) {
        let state = params[0]
        let list = state.getCommonsList()
        this.setupChild(list)
        return true
    };
    Game_Interpreter.prototype.command903 = function (params) {
        let state = params[0]
        state.done = true
        state.getItem()
        if (state.typeIs("ベース")) {
            eval(param.afterStateChange)
            $osawari.isRanning = false
        } else if (state.typeIs("ネクスト")) {
            $osawari.nextState()
        } else if (state.typeIs("リターン")) {
            $osawari.returnState()
        } else if (state.typeIs("リリース")) {
            $osawari.isRanning = false
        } else if (state.typeIs("ジャンプ")) {
            $osawari.setStateByName(state.jump[0])
        } else if (state.typeIs("選択肢")) {
            $gameMessage.setChoices(state.choice, 0, 0);
            $gameMessage.setChoiceCallback(n => {
                $osawari.setStateByName(state.jump[n])
            });
        } else if (state.typeIs("前のベース")) {
            $osawari.setState($osawari.baseStateId - 1)
        } else if (state.typeIs("次のベース")) {
            $osawari.setState($osawari.baseStateId + 1)
        } else if (state.typeIs("aリターン")) {
            $osawari.isRanning = false
        } else if (state.typeIs("リリースリターン")) {
            // $osawari.isRanning = false
        } else if (state.typeIs("ドラッグ")) {
            $osawari.isRanning = false
        }
        return true;
    }

    // var onMessageEnd = null;
    // const Window_Message_terminateMessage = Window_Message.prototype.terminateMessage
    // Window_Message.prototype.terminateMessage = function () {
    //     Window_Message_terminateMessage.apply(this, arguments);
    //     if (onMessageEnd)
    //         onMessageEnd()
    // };


    var onDatabaseLoaded = Scene_Boot.prototype.onDatabaseLoaded
    Scene_Boot.prototype.onDatabaseLoaded = function () {
        onDatabaseLoaded.apply(this, arguments);

        $dataCommonEvents[0] = { id: 0, name: "", switchId: 1, trigger: 0, list: [{ code: 1001, indent: 0, parameters: [] }] }
        $dataSkills = $dataSkills.map((skill) => {
            if (skill)
                return new State(skill)
            else
                return null
        })
    };

    // const _Scene_Map_update = Scene_Map.prototype.update;
    // Scene_Map.prototype.update = function () {
    //     _Scene_Map_update.apply(this, arguments);
    //     s(param.ClickInvalidSwitchId, !($gameMessage.isBusy() || $osawari.isRanning))
    // };

    const _Scene_Map_start = Scene_Map.prototype.start;
    Scene_Map.prototype.start = function () {
        _Scene_Map_start.apply(this, arguments);
        if ($osawari == null)
            $osawari = new Osawari()
        if ($gameScreen._pictures.length < 1)
            $osawari.onNewGame()
        if (this._transfer) {
            $osawari.onMapStart()
            $gameMap.events().forEach(a => a._erased = false)
        }
    };
    // const setup = Scene_Map.prototype.onTransferEnd;
    // Scene_Map.prototype.onTransferEnd = function (mapId) {
    //     setup.apply(this, arguments);

    // }
    const Game_Variables_setValue = Game_Variables.prototype.setValue;
    Game_Variables.prototype.setValue = function (id, value) {
        Game_Variables_setValue.apply(this, arguments);
        if (id == param.charaVar) {
            $osawari.onCharaChange(value)
        } else if (id == param.stateVar) {
            $osawari.onStateChange(value)
        } else if (id == param.angleVar) {
            $osawari.onAngleChange(value)
        } else if (id == param.bgVar) {
            $osawari.onBgChange(value)
        }
    };

    const updateMain = Scene_Map.prototype.updateMain;
    Scene_Map.prototype.updateMain = function () {
        updateMain.apply(this, arguments);
        $osawari.time++;
        if ($osawari.timeoutEnabled && $osawari.timeout < $osawari.time) {
            $osawari.time = 0;
            $osawari.timeoutEnabled = false
            $osawari.onTimeout()
        }
    };



    PluginManagerEx.registerCommand(document.currentScript, "set", args => {
        $osawari.setState(args.id)
    });
    PluginManagerEx.registerCommand(document.currentScript, "next", args => {
        $osawari.nextState()
    });
    PluginManagerEx.registerCommand(document.currentScript, "return", args => {
        $osawari.returnState()
    });
    PluginManagerEx.registerCommand(document.currentScript, "reload", args => {
        $osawari.reload()
    });
    PluginManagerEx.registerCommand(document.currentScript, "setDoneFlags", args => {
        $osawari.setDoneFlags()
    });
    PluginManagerEx.registerCommand(document.currentScript, "resetDoneFlags", args => {
        $osawari.resetDoneFlags()
    });
    PluginManagerEx.registerCommand(document.currentScript, "enableAngle", args => {
        $osawari.enableAngle(args.name)
    });

    PluginManagerEx.registerCommand(document.currentScript, "setObj", args => {
        if (args.name_)
            $gameScreen.picture(param.picIdObj)._name = "obj/" + args.name_
        else
            $gameScreen.picture(param.picIdObj)._name = ""
        //$gameScreen.picture(param.picIdObj).moveToPointer()
    });
    PluginManagerEx.registerCommand(document.currentScript, "setEfc", args => {
        if (args.name_)
            $gameScreen.picture(param.picIdEfc)._name = "efc/" + args.name_
        else
            $gameScreen.picture(param.picIdEfc)._name = ""
        //$gameScreen.picture(param.picIdObj).moveToPointer()
    });

    window.State = State
    window.Osawari = Osawari

})();
